-- MadokaSpacecraftScript
-- Author: Vicevirtuoso
-- DateCreated: 10/28/2014 2:01:08 AM
--------------------------------------------------------------

include("PlotIterators.lua")


local tWishcraftCivs = {}
local bAnyWishcraftCivs;

for i = 0, GameDefines.MAX_MAJOR_CIVS -1, 1 do
	local pPlayer = Players[i]
	if pPlayer:IsEverAlive() then
		if PreGame.GetLoadoutSpacecraft(i) == GameInfo.Spacecraft["SPACECRAFT_WISHCRAFT"].ID then
			tWishcraftCivs[i] = true
			bAnyWishcraftCivs = true
		end
	end
end

if not bAnyWishcraftCivs then
	print("No Civs with Wishcraft on map, no functions will run.")
	return
end

print("Wishcraft script loaded.")

local iRadius = 2
local iHealAmount = 10

function OnPlayerDoTurn(iPlayer)
	if tWishcraftCivs[iPlayer] then
		local pPlayer = Players[iPlayer]
		if pPlayer:IsAlive() then
			local pCapital = pPlayer:GetCapitalCity()
			if pCapital and pCapital:IsOriginalCapital() then
				for pPlot in PlotAreaSpiralIterator(pCapital:Plot(), iRadius) do
					for c = 0, pPlot:GetNumUnits() - 1 do
						local pPlotUnit = pPlot:GetUnit(c)
						if pPlotUnit and pPlotUnit:GetDamage() > 0 then
							if pPlotUnit:GetOwner() == iPlayer then
								pPlotUnit:ChangeDamage(-1 * math.min(pPlotUnit:GetDamage(), iHealAmount))
							end
						end
					end
				end
			end
		end
	end
end

GameEvents.PlayerDoTurn.Add(OnPlayerDoTurn)